#!BPY

"""
Name: 'Arm2Empty'
Blender: 237
Group: 'Wizards'
Tip: 'Create parented empties upon armature'
"""

__author__ = "Jean-Baptiste PERIN"
__url__ = ("blender", "elysiun", "http://jmsoler.free.fr/util/blenderfile/py/bvh_import.py")
__version__ = "0.2 01/12/2005"
__email__= ["M. PERIN Jean-Baptiste, jb_perin@yahoo.fr", "scripts"]
__bpydoc__ = """\
This script create parented empties upon a given armature

Supported:<br>

Missing:<br>

Known issues:<br>

Notes:<br>

"""

#----------------------------------------------
# (c) Jean-Baptiste PERIN  december 2005, released under Blender Artistic Licence
#----------------------------------------------

import Blender

def getRootBone(armature):
	rootBone = None
	for bone in armature.bones.values():
		if bone.parent == None :
			if rootBone == None:
				rootBone = bone
			else:
				print "Multiple root armature not handled"
	return rootBone

def makeParenting(bone):
    lempty = Blender.Object.Get(bone.name)
    if bone.children != None:
        for b in bone.children:
            if bone.name == b.parent.name:
                chld_empt = Blender.Object.Get(b.name)
                lempty.makeParent([chld_empt],0,0)
                makeParenting(b)

print "**** START ****"

armaturename = ""
obj_sel = Blender.Object.GetSelected()
if (obj_sel != None) and (len (obj_sel) == 1) and (type(obj_sel[0].getData()) == Blender.Types.ArmatureType):
    armaturename = obj_sel[0].getName()
    armData = Blender.Object.Get(armaturename).getData()
    for b in armData.bones.values():
        lempty = Blender.Object.New('Empty',b.name)	
        Blender.Scene.getCurrent().link(lempty)
        lempty.setMatrix(b.matrix['ARMATURESPACE'])
        lempty.setLocation(b.head['ARMATURESPACE'])

    makeParenting(getRootBone(armData))
    rootemp = Blender.Object.Get(getRootBone(armData).name)
    rootemp.setLocation(Blender.Object.Get(armaturename).getLocation())
    Blender.Redraw()
else:
     error_txt = "Error%t|Select one and only one armature before running this script"
     Blender.Draw.PupMenu(error_txt)
     print error_txt
    
print "**** END ****"

